#! /usr/bin/perl

# PCS (PPP Connection Stats), v0.3.5, by Jean-Edouard BABIN (Jeb@jeb.com.fr)

# Version 0.1   : Just report Sent/Received for each disconnection and the total
# Version 0.1.1 : look for multiple log place
# Version 0.1.2 : Added connect time
# Version 0.2   : Day summary if multiple disconnection
# Version 0.2.1 : Added the $ext option
# Version 0.2.2 : Mounth summary
# Version 0.3   : Accept multiple log format
# Version 0.3.1 : Print time in the best format (minutes or hours)
# Version 0.3.2 : Some bug corrected when there was more than one disconnection the current day
# Version 0.3.3 : Be able to look in $logfile.x.gz
# Version 0.3.4 : Added Total of disconnections
# Version 0.3.5 : Output in EN or FR (see $lang)

## Planned TODO:
##       - Print output in the best unit (Ko/Mo/Go)    v0.3.4
##       - HTML output option                          v0.4
##       - Be able to run as cgi                       v0.4.1
##       - Output Alignment                            v0.5
##       - Add current sent/received with pppstats (!) v0.5.1
##       - Add more option                             v0.6
##       - Remember old result (log rotation pb)       v0.7
##       - change variable name                        A day
##       - Add some comment                            Every time i think to

$ext = 1; ## extended information for multiple deconnection by day

# if set to 1 you will see normal deconnection output and a summary off the day (gerates number of connection + 1 (for summary) lines)
# if set to 0 you only have 1 output line, the summary of the day

$logpath = "/var/log/daemon.log*";
## Adjust this for your os... may be /var/log/ppp.log* /var/log/messages* ...

$lookingz = 1;
# if set to 1 the script will read .gz log else only text file will be read

$lang = "fr";
# set to fr or en

############## don't touch ! ############

$trad = {
	'after'		=> { 'fr' => 'apres',		'en' => 'after'	},
	'at'		=> { 'fr' => 'a',		'en' => 'at'	},
	'deco'		=> { 'fr' => 'deconnexion',	'en' => 'disconnection'	},
	'decos'		=> { 'fr' => 'deconnexions',	'en' => 'disconnections'},
	'received'	=> { 'fr' => 'recu',		'en' => 'received'	},
	'sent'		=> { 'fr' => 'envoye',		'en' => 'sent'	},
};

$lang = lc $lang;

$sent = 0;
$recv = 0;
lc $lang;

@filelist = glob ( "$logpath" );
@filelist = sort {
#	($b =~ /(\d+)/)[0] <=> ($a =~ /(\d+)/)[0]
	-M $b <=> -M $a
} @filelist;

foreach $file (@filelist) {

	if ($file =~ /\.gz$/) { 
		if ($lookingz eq 1) {
			open(LOG,"zcat $file|")  || die "Log file can't be found: $file: $!"; }
		else { next }
	}
	else { open(LOG,"<$file")  || die "Log file can't be found: $file: $!"; }

# open(LOG,"./daemon.log.0") || open(LOG,"/var/log/ppp.log") || open(LOG,"/var/log/daemon.log") || open(LOG,"/var/log/messages") || die "Log file can't be found";

	while(<LOG>) {
	        if ($_ =~ /^.*\s+\d+\s+.*\s.*\spppd.*Connect time (\d+)/) {
        	        $prevlinetime = $linetime; $linetime = $1;
	        }
	        if ($_ =~ /^(\S+)\s+(\d+)\s+(.*)\s.*\spppd.*Sent (\d+).*received (\d+)/) {
	                $linemonth = $1; $lineday   = $2; $linehours  = $3; $linesent  = $4; $linerecv  = $5;
	                &parse;
	        }
	        elsif ($_ =~ /^(.*)\s+(\d+)\s+(.*)\s.*\sppp.*Connect time: (\d+) secs: (\d+) octets in, (\d+) octets out/) {
			$linemonth = $1; $lineday   = $2; $linehours  = $3; $linesent  = $6; $linerecv  = $5;
	                $prevlinetime = $linetime; $linetime = $4/60; $linetime =~ /^(\d+)/; $linetime = $1;
	                &parse;
	        }
	}

close(LOG);
}

$prevlinetime = $linetime; $res_60 = &divide_60;

if ($day ne "" and $more eq "0") {
	 print "$day ".$month.": $trad->{deco}{$lang} $trad->{at}{$lang} $hours $trad->{after}{$lang} $res_60: $trad->{received}{$lang}: ".$recvd."Mo , $trad->{sent}{$lang}: ".$sentd."Mo\n"; }

if ($more eq "1") {
	$x=$x+1; print "Total of $day ".$month.": $x $trad->{decos}{$lang}: $trad->{received}{$lang}: ".$recvd."Mo , $trad->{sent}{$lang}: ".$sentd."Mo\n"; 
	print "$day ".$month.": $trad->{deco}{$lang} $trad{at}{$lang} $hours $trad->{after}{$lang} $res_60: $trad->{received}{$lang}: ".$recvd."Mo , $trad->{sent}{$lang}: ".$sentd."Mo\n"; }

$sentd3 = $sentd3/(1024*1024); $sentd3 =~/^(\d+)/; $sentd3 = $1;
$recvd3 = $recvd3/(1024*1024); $recvd3 =~/^(\d+)/; $recvd3 = $1;
$x2 = $x2 +1 ;print "Total of ".$month.": $x2 $trad->{decos}{$lang}: $trad->{received}{$lang}: ".$recvd3."Mo , $trad->{sent}{$lang} ".$sentd3."Mo\n";

$recvd3 = 0; $sentd3 = 0 ; $x3 = $x3 + $x2; $x2 = 0; 

$sent = $sent/(1024*1024); $sent =~ /^(\d+)/; $sent = $1;
$recv = $recv/(1024*1024); $recv =~ /^(\d+)/; $recv = $1;

print "- Total: $x3 $trad->{decos}{$lang}\n - $trad->{sent}{$lang}: ".$sent."Mo\n - $trad->{received}{$lang}: ".$recv."Mo\n";

## EOP (end of program)


sub parse {
if ($day eq $lineday and $month eq $linemonth) {
	$res_60 = &divide_60; 
	if ($more eq 0) {
		if ($ext eq 1) { print "$day ".$month.": $trad->{deco}{$lang} $trad->{at}{$lang} $hours $trad->{after}{$lang} $res_60: $trad->{received}{$lang}: ".$recvd."Mo , $trad->{sent}{$lang}: ".$sentd."Mo\n" } 
		else { print "$day ".$month.": $trad->{decos}{$lang}: $trad->{at}{$lang} $hours $trad->{after}{$lang} $res_60, " }
		$x = 1; $x2 = $x2 + 1;
  	}
	else {
		if ($ext eq 1) { print "$day ".$month.": $trad->{deco}{$lang} $trad->{at}{$lang} $hours $trad->{after}{$lang} $res_60: $trad->{received}{$lang}: ".$recvd2."Mo , $trad->{sent}{$lang}: ".$sentd2."Mo\n" }
		else { print "$trad->{at}{$lang} $hours $trad->{after}{$lang} $res_60, "; }
		$x = $x + 1;  $x2 = $x2 + 1;
	}
	$more = 1;
	$sent = $sent + $linesent;                      $recv = $recv + $linerecv;		$hours = $linehours;
	$sentd2 = $linesent/(1024*1024);                $recvd2 = $linerecv/(1024*1024);
	$sentd3 = $sentd3 + $linesent;                  $recvd3 = $recvd3 + $linerecv;
	$sentd = $sentd + $linesent/(1024*1024);        $recvd = $recvd + $linerecv/(1024*1024);
	$sentd2 =~ /^(\d+)/; $sentd2 = $1;		$recvd2 =~ /^(\d+)/; $recvd2 = $1;
	$sentd =~ /^(\d+)/; $sentd = $1;		$recvd =~ /^(\d+)/; $recvd = $1;
} 
else {
	if($day ne "") { 
		$res_60 = &divide_60;
		if ($more eq 0) {
			print "$day ".$month.": $trad->{deco}{$lang} $trad->{at}{$lang} $hours $trad->{after}{$lang} $res_60: $trad->{received}{$lang}: ".$recvd."Mo , $trad->{sent}{$lang}: ".$sentd."Mo\n"; $x2 = $x2 + 1;
		}
		else {
			if ($ext eq 1) {
				print "$day ".$month.": $trad->{deco}{$lang} $trad->{at}{$lang} $hours $trad->{after}{$lang} $res_60: $trad->{received}{$lang}: ".$recvd2."Mo , $trad->{sent}{$lang}: ".$sentd2."Mo\n"; $x = $x + 1; $x2 = $x2 + 1;
				print "Total of $day ".$month.": $x $trad->{decos}{$lang}: $trad->{received}{$lang}: ".$recvd."Mo , $trad->{sent}{$lang}: ".$sentd."Mo\n";
			}
			else { print "$trad->{at}{$lang} $hours $trad->{after}{$lang} $res_60, $trad->{received}{$lang}: ".$recvd."Mo , $trad->{sent}{$lang}: ".$sentd."Mo\n"; }
		}
	}

	$sent = $sent + $linesent;		$recv = $recv + $linerecv;			$more = 0;
	$day = $lineday;                        $oldmonth = $month; $month = $linemonth;	$hours = $linehours;

	if ($month ne $oldmonth and $oldmonth ne "") {
		$sentd3 = $sentd3/(1024*1024); $sentd3 =~/^(\d+)/; $sentd3 = $1;
		$recvd3 = $recvd3/(1024*1024); $recvd3 =~/^(\d+)/; $recvd3 = $1;
		print "Total of ".$oldmonth.": $x2 $trad->{decos}{$lang}: $trad->{received}{$lang}: ".$recvd3."Mo , $trad->{sent}{$lang}: ".$sentd3."Mo\n";
		$recvd3 = 0; $sentd3 = 0; $x3 = $x3 + $x2; $x2 = 0;
	}

	$sentd = $linesent/(1024*1024);                 $recvd = $linerecv/(1024*1024);
	$sentd3 = $sentd3 + $linesent;                  $recvd3 = $recvd3 + $linerecv;
	$sentd =~ /^(\d+)/; $sentd = $1;		$recvd =~ /^(\d+)/; $recvd = $1;
}
}


sub divide_60 {
$hres = 0; $mres = "00";
if ($prevlinetime > 600) { $res = ($prevlinetime/60);
if ($res =~ /\./) { $res =~ /(\d+)\.(\d+)/; $hres = $1; $mres = ($2/100)*60; $mres =~ /^(..)/; $mres = $1;  } else { $res =~ /(\d+)/; $hres = $1; }
$result = "$hres\H$mres"; }
else { $result = "$prevlinetime minutes"; }
return $result
}
